Partial Tree ICPC 2015 Changchun 完全背包

2023-10-04 02:30

本文主要是介绍Partial Tree ICPC 2015 Changchun 完全背包,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

9262: Partial Tree

时间限制: 1 Sec  内存限制: 128 MB
提交: 70  解决: 29
[提交] [状态] [讨论版] [命题人:admin]

题目描述

In mathematics, and more specifically in graph theory, a tree is an undirected graph in which any two nodes are connected by exactly one path. In other words, any connected graph without simple cycles is a tree.
You find a partial tree on the way home. This tree has n nodes but lacks of n   1 edges. You want to complete this tree by adding n - 1 edges. There must be exactly one path between any two nodes after adding. As you know, there are nn−2 ways to complete this tree, and you want to make the completed tree as cool as possible.
The coolness of a tree is the sum of coolness of its nodes. The coolness of a node is f(d), where f is a predefined function and d is the degree of this node. What’s the maximum coolness of the completed tree?

 

输入

The first line contains an integer T indicating the total number of test cases. Each test case starts with an integer
n in one line, then one line with n-1 integers f(1), f(2), . . . , f(n-1).
1≤T≤2015
2≤n≤2015
0≤f(i)≤10000
There are at most 10 test cases with n > 100.

 

输出

For each test case, please output the maximum coolness of the completed tree in one line.

 

样例输入

2
3
2 1
4
5 1 4

 

样例输出

5
19

 

来源/分类

ICPC 2015 Changchun 

 

[提交] [状态]

比赛时看到这道题感觉是窒息的,但是赛后看题解更窒息,完全想不到是个背包,极其震惊

题意:给n各点,分配n-1条边,使每个点的度i对应的f( i )相加的和最大,f(i)给出

思路:大佬说,不管怎么建树,只要能够保证每个点的度至少为一,那么总是存在一棵树满足你的度数分配要求,那么只需要把

度数分配下去,并且每个点的度数至少为1,所以先给每个点都分配1的度数,所以最初的2n-2的度数就剩下了n-2的度数。

然后就可以看作完全背包的问题,把n-2总度数看作总空间的体积,每个i为体积,f(i)为对应的权值,然后在满足总体积的前提

下让权值最大

代码:

#include <bits/stdc++.h>using namespace std;
const int mod = 1e9 + 7;
const int maxn = 1e4+10;
const int inf = 0x3f3f3f3f;
typedef long long ll;
ll f[maxn],dp[maxn];
int main() {int t;scanf("%d",&t);while(t--){int n;scanf("%d",&n);for(int i=1; i<n; i++){scanf("%lld",&f[i]);dp[i]=-inf;}dp[n]=-inf;dp[0]=f[1]*n;for(int i=1; i<n-1; i++){for(int j=i; j<=n-2; j++){dp[j]=max(dp[j],dp[j-i]+f[i+1]-f[1]);}}printf("%lld\n",dp[n-2]);}return 0;
}

 

这篇关于Partial Tree ICPC 2015 Changchun 完全背包的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/1133

相关文章

poj2576(二维背包)

题意:n个人分成两组,两组人数只差小于1 , 并且体重只差最小 对于人数要求恰好装满,对于体重要求尽量多,一开始没做出来,看了下解题,按照自己的感觉写,然后a了 状态转移方程:dp[i][j] = max(dp[i][j],dp[i-1][j-c[k]]+c[k]);其中i表示人数,j表示背包容量,k表示输入的体重的 代码如下: #include<iostream>#include<

hdu2159(二维背包)

这是我的第一道二维背包题,没想到自己一下子就A了,但是代码写的比较乱,下面的代码是我有重新修改的 状态转移:dp[i][j] = max(dp[i][j], dp[i-1][j-c[z]]+v[z]); 其中dp[i][j]表示,打了i个怪物,消耗j的耐力值,所得到的最大经验值 代码如下: #include<iostream>#include<algorithm>#include<

csu(背包的变形题)

题目链接 这是一道背包的变形题目。好题呀 题意:给n个怪物,m个人,每个人的魔法消耗和魔法伤害不同,求打死所有怪物所需的魔法 #include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>//#include<u>#include<map

hdu1011(背包树形DP)

没有完全理解这题, m个人,攻打一个map,map的入口是1,在攻打某个结点之前要先攻打其他一个结点 dp[i][j]表示m个人攻打以第i个结点为根节点的子树得到的最优解 状态转移dp[i][ j ] = max(dp[i][j], dp[i][k]+dp[t][j-k]),其中t是i结点的子节点 代码如下: #include<iostream>#include<algorithm

hdu1171(母函数或多重背包)

题意:把物品分成两份,使得价值最接近 可以用背包,或者是母函数来解,母函数(1 + x^v+x^2v+.....+x^num*v)(1 + x^v+x^2v+.....+x^num*v)(1 + x^v+x^2v+.....+x^num*v) 其中指数为价值,每一项的数目为(该物品数+1)个 代码如下: #include<iostream>#include<algorithm>

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

uva 10130 简单背包

题意: 背包和 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstring>#include <cmath>#include <stack>#include <vector>#include <queue>#include <map>

HDU 2159 二维完全背包

FATE 最近xhd正在玩一款叫做FATE的游戏,为了得到极品装备,xhd在不停的杀怪做任务。久而久之xhd开始对杀怪产生的厌恶感,但又不得不通过杀怪来升完这最后一级。现在的问题是,xhd升掉最后一级还需n的经验值,xhd还留有m的忍耐度,每杀一个怪xhd会得到相应的经验,并减掉相应的忍耐度。当忍耐度降到0或者0以下时,xhd就不会玩这游戏。xhd还说了他最多只杀s只怪。请问他能

多重背包转换成0-1背包

http://acm.hdu.edu.cn/showproblem.php?pid=2191 多重背包特点: 一种物品有C个(既不是固定的1个,也不是无数个) 优化的方法: 运用神奇的二进制,进行物品拆分,转化成01背包 物品拆分,把13个相同的物品分成4组(1,2,4,6) 用这4组可以组成任意一个1~13之间的数! 原理:一个数总可以用2^

zoj 1721 判断2条线段(完全)相交

给出起点,终点,与一些障碍线段。 求起点到终点的最短路。 枚举2点的距离,然后最短路。 2点可达条件:没有线段与这2点所构成的线段(完全)相交。 const double eps = 1e-8 ;double add(double x , double y){if(fabs(x+y) < eps*(fabs(x) + fabs(y))) return 0 ;return x + y ;